## perl-5.8.8.tar.bz2

=== vos/Makefile ===
#
# This Makefile can be used to update the config.alpha.h and
# config.ga.h files *in UNIX* (in VOS the configure_perl.cm
# is used).  Update the config.*.def files appropriately when
# you add new symbols to Configure.  If you don't know VOS,
# most of the time a safe guess for a symbol is 'undef'.
#

all:	config.alpha.h config.ga.h

config.alpha.h:	config.alpha.def ../config_h.SH mv-if-diff
	cp config.alpha.def config.def
	perl config.pl
	sh mv-if-diff config.h.new config.alpha.h
	rm -f config.def config.h.new

config.ga.h:	config.ga.def ../config_h.SH mv-if-diff
	cp config.ga.def config.def
	perl config.pl
	sh mv-if-diff config.h.new config.ga.h
	rm -f config.def config.h.new

=== win32/Makefile ===
#
# Makefile to build perl on Windows NT using Microsoft NMAKE.
# Supported compilers:
#	Visual C++ 2.0 through 7.0 (and possibly newer versions)
#	MS Platform SDK 64-bit compiler and tools **experimental**
#
# This is set up to build a perl.exe that runs off a shared library
# (perl58.dll).  Also makes individual DLLs for the XS extensions.
#

##
## Make sure you read README.win32 *before* you mess with anything here!
##

##
## Build configuration.  Edit the values below to suit your needs.
##

#
# Set these to wherever you want "nmake install" to put your
# newly built perl.
#
INST_DRV	= c:
INST_TOP	= $(INST_DRV)\perl

#
# Comment this out if you DON'T want your perl installation to be versioned.
# This means that the new installation will overwrite any files from the
# old installation at the same INST_TOP location.  Leaving it enabled is
# the safest route, as perl adds the extra version directory to all the
# locations it installs files to.  If you disable it, an alternative
# versioned installation can be obtained by setting INST_TOP above to a
# path that includes an arbitrary version string.
#
#INST_VER	= \5.8.8

#
# Comment this out if you DON'T want your perl installation to have
# architecture specific components.  This means that architecture-
# specific files will be installed along with the architecture-neutral
# files.  Leaving it enabled is safer and more flexible, in case you
# want to build multiple flavors of perl and install them together in
# the same location.  Commenting it out gives you a simpler
# installation that is easier to understand for beginners.
#
#INST_ARCH	= \$(ARCHNAME)

#
# Uncomment this if you want perl to run
# 	$Config{sitelibexp}\sitecustomize.pl
# before anything else.  This script can then be set up, for example,
# to add additional entries to @INC.
#
#USE_SITECUST	= define

#
# uncomment to enable multiple interpreters.  This is need for fork()
# emulation and for thread support.
#
USE_MULTI	= define

#
# Beginnings of interpreter cloning/threads; now reasonably complete.
# This should be enabled to get the fork() emulation.  This needs
# USE_MULTI as well.
#
USE_ITHREADS	= define

#
# uncomment to enable the implicit "host" layer for all system calls
# made by perl.  This needs USE_MULTI above.  This is also needed to
# get fork().
#
USE_IMP_SYS	= define

#
# Comment out next assign to disable perl's I/O subsystem and use compiler's 
# stdio for IO - depending on your compiler vendor and run time library you may 
# then get a number of fails from make test i.e. bugs - complain to them not us ;-). 
# You will also be unable to take full advantage of perl5.8's support for multiple 
# encodings and may see lower IO performance. You have been warned.
USE_PERLIO	= define

#
# Comment this out if you don't want to enable large file support for
# some reason.  Should normally only be changed to maintain compatibility
# with an older release of perl.
USE_LARGE_FILES	= define

#
# WARNING! This option is deprecated and will eventually go away (enable
# USE_ITHREADS instead).
#
# uncomment to enable threads-capabilities.  This is incompatible with
# USE_ITHREADS, and is only here for people who may have come to rely
# on the experimental Thread support that was in 5.005.
#
#USE_5005THREADS	= define

#
# uncomment exactly one of the following
#
# Visual C++ 2.x
#CCTYPE		= MSVC20
# Visual C++ > 2.x and < 6.x
#CCTYPE		= MSVC
# Visual C++ 6.x (aka Visual Studio 98)
CCTYPE		= MSVC60
# Visual C++ Toolkit 2003 (free version of Visual C++ 7.x command-line tools)
#CCTYPE		= MSVC70FREE
# Visual C++ 7.x (aka Visual Studio .NET 2003) (full version)
#CCTYPE		= MSVC70

#
# uncomment next line if you want debug version of perl (big,slow)
# If not enabled, we automatically try to use maximum optimization
# with all compilers that are known to have a working optimizer.
#
#CFG		= Debug

#
# uncomment to enable use of PerlCRT.DLL when using the Visual C compiler.
# It has patches that fix known bugs in older versions of MSVCRT.DLL.
# This currently requires VC 5.0 with Service Pack 3 or later.
# Get it from CPAN at http://www.cpan.org/authors/id/D/DO/DOUGL/
# and follow the directions in the package to install.
#
# Not recommended if you have VC 6.x and you're not running Windows 9x.
#
#USE_PERLCRT	= define

#
# uncomment to enable linking with setargv.obj under the Visual C
# compiler. Setting this options enables perl to expand wildcards in
# arguments, but it may be harder to use alternate methods like
# File::DosGlob that are more powerful.  This option is supported only with
# Visual C.
#
#USE_SETARGV	= define

#
# if you want to have the crypt() builtin function implemented, leave this or
# CRYPT_LIB uncommented.  The fcrypt.c file named here contains a suitable
# version of des_fcrypt().
#
CRYPT_SRC	= fcrypt.c

#
# if you didn't set CRYPT_SRC and if you have des_fcrypt() available in a
# library, uncomment this, and make sure the library exists (see README.win32)
# Specify the full pathname of the library.
#
#CRYPT_LIB	= fcrypt.lib

#
# set this if you wish to use perl's malloc
# WARNING: Turning this on/off WILL break binary compatibility with extensions
# you may have compiled with/without it.  Be prepared to recompile all
# extensions if you change the default.  Currently, this cannot be enabled
# if you ask for USE_IMP_SYS above.
#
#PERL_MALLOC	= define

#
# set this to enable debugging mstats
# This must be enabled to use the Devel::Peek::mstat() function.  This cannot
# be enabled without PERL_MALLOC as well.
#
#DEBUG_MSTATS	= define

#
#
# set the install locations of the compiler include/libraries
# Running VCVARS32.BAT is *required* when using Visual C.
# Some versions of Visual C don't define MSVCDIR in the environment,
# so you may have to set CCHOME explicitly (spaces in the path name should
# not be quoted)
#
#CCHOME		= f:\msvc20
CCHOME		= $(MSVCDIR)
CCINCDIR	= $(CCHOME)\include
CCLIBDIR	= $(CCHOME)\lib

#
# Additional compiler flags can be specified here.
#
BUILDOPT	= $(BUILDOPTEXTRA)

# Adding -DPERL_HASH_SEED_EXPLICIT will disable randomization of Perl's
# internal hash function unless the PERL_HASH_SEED environment variable is set.
# Alternatively, adding -DNO_HASH_SEED will completely disable the
# randomization feature. 
# The latter is required to maintain binary compatibility with Perl 5.8.0.
#
#BUILDOPT	= $(BUILDOPT) -DPERL_HASH_SEED_EXPLICIT
#BUILDOPT	= $(BUILDOPT) -DNO_HASH_SEED

#
#
# This should normally be disabled.  Adding -DPERL_POLLUTE enables support
# for old symbols by default, at the expense of extreme pollution.  You most
# probably just want to build modules that won't compile with
#         perl Makefile.PL POLLUTE=1
# instead of enabling this.  Please report such modules to the respective
# authors.
#
#BUILDOPT	= $(BUILDOPT) -DPERL_POLLUTE

#
# This should normally be disabled.  Enabling it will disable the File::Glob
# implementation of CORE::glob.
#
#BUILDOPT	= $(BUILDOPT) -DPERL_EXTERNAL_GLOB

#
# This should normally be disabled.  Enabling it causes perl to read scripts
# in text mode (which is the 5.005 behavior) and will break ByteLoader.
#
#BUILDOPT	= $(BUILDOPT) -DPERL_TEXTMODE_SCRIPTS

#
# specify semicolon-separated list of extra directories that modules will
# look for libraries (spaces in path names need not be quoted)
#
EXTRALIBDIRS	=

#
# set this to your email address (perl will guess a value from
# from your loginname and your hostname, which may not be right)
#
#EMAIL		=

##
## Build configuration ends.
##

##################### CHANGE THESE ONLY IF YOU MUST #####################

!IF "$(CRYPT_SRC)$(CRYPT_LIB)" == ""
D_CRYPT		= undef
!ELSE
D_CRYPT		= define
CRYPT_FLAG	= -DHAVE_DES_FCRYPT
!ENDIF

!IF "$(USE_IMP_SYS)" == "define"
PERL_MALLOC	= undef
DEBUG_MSTATS	= undef
!ENDIF

!IF "$(PERL_MALLOC)" == ""
PERL_MALLOC	= undef
DEBUG_MSTATS	= undef
!ENDIF

!IF "$(DEBUG_MSTATS)" == ""
DEBUG_MSTATS	= undef
!ENDIF

!IF "$(DEBUG_MSTATS)" == "define"
BUILDOPT	= $(BUILDOPT) -DPERL_DEBUGGING_MSTATS
!ENDIF

!IF "$(USE_5005THREADS)" == ""
USE_5005THREADS	= undef
!ENDIF

!IF "$(USE_5005THREADS)" == "define"
USE_ITHREADS	= undef
!ENDIF

!IF "$(USE_SITECUST)" == ""
USE_SITECUST	= undef
!ENDIF

!IF "$(USE_MULTI)" == ""
USE_MULTI	= undef
!ENDIF

!IF "$(USE_ITHREADS)" == ""
USE_ITHREADS	= undef
!ENDIF

!IF "$(USE_IMP_SYS)" == ""
USE_IMP_SYS	= undef
!ENDIF

!IF "$(USE_PERLIO)" == ""
USE_PERLIO	= undef
!ENDIF

!IF "$(USE_LARGE_FILES)" == ""
USE_LARGE_FILES	= undef
!ENDIF

!IF "$(USE_PERLCRT)" == ""
USE_PERLCRT	= undef
!ENDIF

!IF "$(USE_IMP_SYS)$(USE_MULTI)$(USE_5005THREADS)" == "defineundefundef"
USE_MULTI	= define
!ENDIF

!IF "$(USE_ITHREADS)$(USE_MULTI)" == "defineundef"
USE_MULTI	= define
USE_5005THREADS	= undef
!ENDIF

!IF "$(USE_SITECUST)" == "define"
BUILDOPT	= $(BUILDOPT) -DUSE_SITECUSTOMIZE
!ENDIF

!IF "$(USE_MULTI)$(USE_5005THREADS)" != "undefundef"
BUILDOPT	= $(BUILDOPT) -DPERL_IMPLICIT_CONTEXT
!ENDIF

!IF "$(USE_IMP_SYS)" != "undef"
BUILDOPT	= $(BUILDOPT) -DPERL_IMPLICIT_SYS
!ENDIF

!IF "$(PROCESSOR_ARCHITECTURE)" == ""
PROCESSOR_ARCHITECTURE	= x86
!ENDIF

!IF "$(WIN64)" == ""
!IF "$(PROCESSOR_ARCHITEW6432)" != ""
PROCESSOR_ARCHITECTURE	= $(PROCESSOR_ARCHITEW6432)
WIN64			= define
!ELSE
!IF "$(PROCESSOR_ARCHITECTURE)" == "IA64"
WIN64			= define
!ELSE
WIN64			= undef
!ENDIF
!ENDIF
!ENDIF

!IF "$(USE_5005THREADS)" == "define"
ARCHNAME	= MSWin32-$(PROCESSOR_ARCHITECTURE)-thread
!ELSE
!IF "$(USE_MULTI)" == "define"
ARCHNAME	= MSWin32-$(PROCESSOR_ARCHITECTURE)-multi
!ELSE
!IF "$(USE_PERLIO)" == "define"
ARCHNAME	= MSWin32-$(PROCESSOR_ARCHITECTURE)-perlio
!ELSE
ARCHNAME	= MSWin32-$(PROCESSOR_ARCHITECTURE)
!ENDIF
!ENDIF
!ENDIF

!IF "$(USE_PERLIO)" == "define"
BUILDOPT	= $(BUILDOPT) -DUSE_PERLIO
!ENDIF

!IF "$(USE_ITHREADS)" == "define"
ARCHNAME	= $(ARCHNAME)-thread
!ENDIF

# Visual Studio 98 and .NET 2003 specific
# VC++ 6.x and 7.x can load DLL's on demand.  Makes the test suite run in
# about 10% less time.  (The free version of 7.x can't do this, however.)
!IF "$(CCTYPE)" == "MSVC60" || "$(CCTYPE)" == "MSVC70"
DELAYLOAD	= -DELAYLOAD:ws2_32.dll -DELAYLOAD:shell32.dll delayimp.lib
!ENDIF

ARCHDIR		= ..\lib\$(ARCHNAME)
COREDIR		= ..\lib\CORE
AUTODIR		= ..\lib\auto
LIBDIR		= ..\lib
EXTDIR		= ..\ext
PODDIR		= ..\pod
EXTUTILSDIR	= $(LIBDIR)\ExtUtils

#
INST_SCRIPT	= $(INST_TOP)$(INST_VER)\bin
INST_BIN	= $(INST_SCRIPT)$(INST_ARCH)
INST_LIB	= $(INST_TOP)$(INST_VER)\lib
INST_ARCHLIB	= $(INST_LIB)$(INST_ARCH)
INST_COREDIR	= $(INST_ARCHLIB)\CORE
INST_POD	= $(INST_LIB)\pod
INST_HTML	= $(INST_TOP)$(INST_VER)\html

#
# Programs to compile, build .lib files and link
#

CC		= cl
LINK32		= link
LIB32		= $(LINK32) -lib
RSC		= rc

#
# Options
#

INCLUDES	= -I$(COREDIR) -I.\include -I. -I..
#PCHFLAGS	= -Fpc:\temp\vcmoduls.pch -YX
DEFINES		= -DWIN32 -D_CONSOLE -DNO_STRICT $(CRYPT_FLAG)
LOCDEFS		= -DPERLDLL -DPERL_CORE
SUBSYS		= console
CXX_FLAG	= -TP -GX

!IF "$(USE_PERLCRT)" != "define"
LIBC	= msvcrt.lib
!ELSE
LIBC	= PerlCRT.lib
!ENDIF

!IF  "$(CFG)" == "Debug"
!  IF "$(CCTYPE)" == "MSVC20"
OPTIMIZE	= -Od -MD -Z7 -DDEBUGGING
!  ELSE
OPTIMIZE	= -Od -MD -Zi -DDEBUGGING
!  ENDIF
LINK_DBG	= -debug
!ELSE
OPTIMIZE	= -MD -Zi -DNDEBUG
# we enable debug symbols in release builds also
LINK_DBG	= -debug -opt:ref,icf
# you may want to enable this if you want COFF symbols in the executables
# in addition to the PDB symbols.  The default Dr. Watson that ships with
# Windows can use the the former but not latter.  The free WinDbg can be
# installed to get better stack traces from just the PDB symbols, so we
# avoid the bloat of COFF symbols by default.
#LINK_DBG	= $(LINK_DBG) -debugtype:both
!  IF "$(WIN64)" == "define"
# enable Whole Program Optimizations (WPO) and Link Time Code Generation (LTCG)
OPTIMIZE	= $(OPTIMIZE) -Ox -GL
LINK_DBG	= $(LINK_DBG) -ltcg
!  ELSE
# -O1 yields smaller code, which turns out to be faster than -O2 on x86
OPTIMIZE	= $(OPTIMIZE) -O1
#OPTIMIZE	= $(OPTIMIZE) -O2
!  ENDIF
!ENDIF

!IF "$(WIN64)" == "define"

=== debian/changelog ===
perl (5.8.8-7) unstable; urgency=low

  * Apply optimisation for File::Spec->abs2rel suggested by joeyh
    (closes: #376658).

  * Patch perl5db.pl to cope with lines from a remote socket requiring
    multiple calls to recv (fixes a problem reported by EPIC folks).

  * Merge NMU.

  [Marc 'HE' Brockschmidt] (closes: #398331)
  * Completly replace libnet-perl:
   + Integrate some patches for the Net:: modules
   + debian/control: Update to replace the last libnet-perl version.
   + Update configuration mechanism so that /etc/perl/Net/libnet.cfg
     sources in /etc/libnet.cfg if it exists, otherwise the
     configuration is stored there. This saves us trouble from
     converting debconf-managed /etc/libnet.cfg to a dpkg conffile

 -- Brendan O'Dea <bod@debian.org>  Sun, 19 Nov 2006 01:07:26 +1100

perl (5.8.8-6.1) unstable; urgency=high

  * Non-maintainer upload to fix Failure To Build From Source in hppa, mips
    and mipsel architectures.
  * Added debian/patches/74_debian_hppa_mips_optim, that forces pp_pack.c to
    be compiled without the delayed-branch optimization option.
    (Closes: #374396)

 -- Margarita Manterola <marga@debian.org>  Sun,  6 Aug 2006 11:50:18 -0300

perl (5.8.8-6) unstable; urgency=low

  * Work around g++-4.1 issue with register parameter declarations.
  * Add errno.ph (simple wrapper around Errno module).

 -- Brendan O'Dea <bod@debian.org>  Sun, 11 Jun 2006 22:38:12 +1000

perl (5.8.8-5) unstable; urgency=low

  * Correctly identify arch-specific modules in ext/ where the .pm
    files are under lib.  Adjust perl-base.files (closes: #369481).

  * Ensure that POSIX/SigAction is kept with the rest of the POSIX
    module under archlib.

  * Apply upstream change 26536: add INSTALL{VENDOR,SITE}SCRIPT
    macros (closes: #362949).

  * [Don Armstrong] Revert part of upstream change 24524 to always use
    PERLRUNINST when building perl modules (closes: #357264).

 -- Brendan O'Dea <bod@debian.org>  Sat,  3 Jun 2006 17:06:45 +1000

perl (5.8.8-4) unstable; urgency=low

  * Preserve timestamps in /usr/share/doc.
  * Revert Sys::Syslog change (see: #345157).
  * Fix typo in perlsec(1) (closes: #358455).
  * Change build-dep on procps to "procps|hurd" (closes: #357699).

 -- Brendan O'Dea <bod@debian.org>  Wed,  5 Apr 2006 01:30:11 +1000

perl (5.8.8-3) unstable; urgency=low

  * Add build-dep on procps (required by t/op/magic).
  * Remove trailing \0 from Sys::Syslog messages (closes: #345157).
  * Getopt::Long:  allow "ignorecase_always" as a synonym for
    "ignore_case_always" to match the documention (closes #354197).

  * Don't add -Wdeclaration-after-statement to ccflags: this causes
    problems when building extensions with gcc-3.3 .

  * Pod::Man: don't translate "|" (closes: #291391).

 -- Brendan O'Dea <bod@debian.org>  Fri, 10 Mar 2006 03:07:28 +1100

perl (5.8.8-2) unstable; urgency=low

  * Move overload.pm back to perl-base (closes: #352060).
  * Extend timer in Time::HiRes test to 5 mins (for m68k).

 -- Brendan O'Dea <bod@debian.org>  Fri, 10 Feb 2006 06:23:17 +1100

perl (5.8.8-1) unstable; urgency=low

  * New upstream version.
  * Update perl-base conflict versions for:
      libscalar-list-utils-perl (1.18).

  * Update perl conflict versions for:
      libdigest-md5-perl (2.36),
      libmime-base64-perl (3.07),
      libstorable-perl (2.15) and
      libtime-hires-perl (1.86).

  * Update perl-modules conflict versions for:
      libattribute-handlers-perl (0.78_02),
      libcgi-pm-perl (3.15),
      libpod-parser-perl (1.32),
      libansicolor-perl (1.10),
      libtest-harness-perl (2.56) and
      libtest-simple-perl (0.62).

  * Revert debian/patches/02_fix_file_path to upstream fix.
  * Update to DB_File to db4.4.
  * Move Data::Dumper and overload from perl-base to perl now that
    debconf no longer requires Data::Dumper.

 -- Brendan O'Dea <bod@debian.org>  Sat,  4 Feb 2006 19:33:24 +1100

perl (5.8.7-10) unstable; urgency=low

  * Remove DB_File version checks (closes: #340047, #343335).
  * Remove Errno version check, which can cause problems with long-running
    processes that embed perl when perl is upgraded (closes: #343351)

  * Apply upstream 26321: Disallow sprintf's vector handling for
    non-integer formats.

 -- Brendan O'Dea <bod@debian.org>  Fri, 16 Dec 2005 01:32:14 +1100

perl (5.8.7-9) unstable; urgency=high

  * SECURITY [CVE-2005-3962] (closes: #341542):
    + Apply upstream fixes to prevent buffer overflows in
      printf/sprintf caused by malicious format strings.
    + Update Sys::Syslog to 0.09, which only uses the message as a
      format string to sprintf when additional arguments are given.

  * Remove -Dusemymalloc from perl-debug (added for #178243: to
    enable PERL_DEBUGGING_MSTATS), as this causes debugperl to break with
    compiled modules.  Closes: #337050, #342526).

  * Skip Math::Complex tests 267 and 487, failing due to non-IEEE fp
    rounding rules in the kernel fp emulation.

 -- Brendan O'Dea <bod@debian.org>  Sat, 10 Dec 2005 16:43:02 +1100

perl (5.8.7-8) unstable; urgency=low

  * ARM fix is also required for armeb.
  * Skip lib/Net/hostent.t test if no /etc/hosts (some buildds).
  * Fix debugger termination message to refer to "o" rather than "O" for
    setting options (closes: #334516).

  * Fix problem with untainting of captured $N (thanks to Chris Heath
    for analysis and patch; closes: #303308).

  * Fix h2ph to correctly locate gcc's include directory (closes: #328500).
  * Update to DB_File to db4.3 (closes: #336486).

 -- Brendan O'Dea <bod@debian.org>  Sun, 13 Nov 2005 12:05:29 +1100

perl (5.8.7-7) unstable; urgency=low

  * ARM optimisation fix take 2.  Downgrade optimisation of pp_pack to
    -Os (closes:  #333510).  Thanks to Bill Gatliff for the extended
    use of the CSB625 is his basement.

  * Change section of perl-base to "perl".

 -- Brendan O'Dea <bod@debian.org>  Mon, 17 Oct 2005 23:16:32 +1000

perl (5.8.7-6) unstable; urgency=low



=== debian/control ===
Source: perl
Section: perl
Priority: standard
Maintainer: Brendan O'Dea <bod@debian.org>
Standards-Version: 3.6.2
Build-Depends: file, cpio (>= 2.6-5), libdb4.4-dev, libgdbm-dev, netbase [!hurd-i386], gcc (>= 4:4.0), procps | hurd

Package: perl-base
Essential: yes
Priority: required
Architecture: any
Pre-Depends: ${shlibs:Depends}
Conflicts: perl-5.004-base (<< 6), perl-5.005-base (<< 6), perl-5.6-base (<< 6), autoconf2.13 (<< 2.13-45), libscalar-list-utils-perl (<< 1:1.18-1)
Replaces: perl-5.005-base (<< 6), perl-5.6-base (<< 6), perl (<< 5.8.8-5), perl-modules (<< 5.8.8-2), libperl5.8 (<< 5.8.0-20), libscalar-list-utils-perl, libclass-multimethods-perl (<< 1.70-4)
Provides: perl5-base, ${perlapi:Provides}, libscalar-list-utils-perl
Suggests: perl
Description: The Pathologically Eclectic Rubbish Lister
 A scripting language with delusions of full language-hood, Perl is used
 in many system scripts and utilities.
 .
 This is a stripped down Perl with only essential libraries.  To make
 full use of Perl, you'll want to install the `perl', `perl-modules' and
 optionally `perl-doc' packages which supplement this one.

Package: libcgi-fast-perl
Priority: optional
Architecture: all
Depends: perl (>= ${Source-Version}), libfcgi-perl
Description: CGI::Fast Perl module
 CGI::Fast is a subclass of the CGI object created by CGI.pm.  It is
 specialized to work well with the Open Market FastCGI standard, which
 greatly speeds up CGI scripts by turning them into persistently running
 server processes.  Scripts that perform time-consuming initialization
 processes, such as loading large modules or opening persistent database
 connections, will see large performance improvements.

Package: perl-doc
Section: doc
Priority: optional
Architecture: all
Depends: perl (>= ${Upstream-Version}-1)
Conflicts: perl-5.004-doc (<< 6), perl-5.005-doc (<< 6), perl-5.6-doc (<< 6)
Replaces: perl-5.005-doc (<< 6), perl-5.6-doc (<< 6)
Suggests: man-browser, groff
Description: Perl documentation
 Perl manual pages, POD documentation and the `perldoc' program.  If you are
 writing Perl programs, you almost certainly need this.

Package: perl-modules
Priority: standard
Architecture: all
Depends: perl (>= ${Upstream-Version}-1)
Conflicts: libpod-parser-perl (<< 1.32-1), libansicolor-perl (<< 1.10-1), libfile-temp-perl (<< 0.16-1), libnet-perl (<= 1:1.19-3), libattribute-handlers-perl (<< 0.78_02-1), libcgi-pm-perl (<< 3.15-1), libi18n-langtags-perl (<< 0.35-1), liblocale-maketext-perl (<< 1.08-1), libmath-bigint-perl (<< 1.77-1), libnet-ping-perl (<< 2.31-1), libtest-harness-perl (<< 2.56-1), libtest-simple-perl (<< 0.62-1), liblocale-codes-perl (<< 2.06.1-1)
Replaces: libpod-parser-perl, libansicolor-perl, libfile-temp-perl, libnet-perl, libattribute-handlers-perl, libcgi-pm-perl, libi18n-langtags-perl, liblocale-maketext-perl, libmath-bigint-perl, libnet-ping-perl, libtest-harness-perl, libtest-simple-perl, liblocale-codes-perl
Provides: libpod-parser-perl, libansicolor-perl, libfile-temp-perl, libnet-perl, libattribute-handlers-perl, libcgi-pm-perl, libi18n-langtags-perl, liblocale-maketext-perl, libmath-bigint-perl, libnet-ping-perl, libtest-harness-perl, libtest-simple-perl, liblocale-codes-perl
Description: Core Perl modules
 Architecture independent Perl modules.  These modules are part of Perl and
 required if the `perl' package is installed.

Package: perl-debug
Priority: optional
Architecture: any
Depends: perl (= ${Source-Version}), ${shlibs:Depends}
Conflicts: perl-5.004-debug (<< 6), perl-5.005-debug (<< 6), perl-5.6-debug (<< 6)
Replaces: perl-5.005-debug (<< 6), perl-5.6-debug (<< 6)
Description: Debug-enabled Perl interpreter
 debugperl provides a debug-enabled version of Perl which can produce
 extensive information about the interpreter as it compiles and executes
 a program (see the -D switch in perlrun(1)).
 .
 Note that this package is primarily of use in debugging *Perl* rather
 than perl programs, which may be traced/debugged using the standard
 perl binary using the -d switch (see perldebug(1)).

Package: perl-suid
Priority: optional
Architecture: any
Depends: perl (= ${Source-Version}), ${shlibs:Depends}
Conflicts: perl-5.004-suid (<< 6), perl-5.005-suid (<< 6), perl-5.6-suid (<< 6)
Replaces: perl-5.005-suid (<< 6), perl-5.6-suid (<< 6)
Description: Runs setuid Perl scripts
 suidperl is a setuid root helper program which is invoked by perl when
 executing scripts with setuid/gid bits set on systems (like linux) which
 don't have support setuid script execution natively in the kernel.
 .
 Usage of this program is now strongly deprecated upstream and support
 (along with this package) will probably be removed in 5.10.

Package: libperl5.8
Section: libs
Priority: optional
Architecture: any
Depends: ${shlibs:Depends}, perl-base (= ${Source-Version})
Conflicts: libapache-mod-perl (<< 1.29.0.1-3)
Replaces: perl-base (<= 5.8.7-4)
Description: Shared Perl library
 This package is required by programs which embed a Perl interpreter to
 ensure that the correct version of `perl-base' is installed.  It
 additionally contains the shared Perl library on architectures where the
 perl binary is linked to libperl.a (currently only i386, for performance
 reasons).  In other cases the actual library is in the `perl-base' package.

Package: libperl-dev
Section: libdevel
Priority: optional
Architecture: any
Depends: perl (= ${Source-Version}), libperl5.8 (= ${Source-Version})
Description: Perl library: development files
 Files for developing applications which embed a Perl interpreter and for
 programs compiled with perlcc.

Package: perl
Priority: standard
Architecture: any
Depends: perl-base (= ${Source-Version}), perl-modules (>= ${Source-Version}), ${shlibs:Depends}
Conflicts: data-dumper, perl-5.004 (<< 6), perl-5.005 (<< 6), perl-5.6 (<< 6), perl-doc (<< ${Upstream-Version}-1), libdigest-md5-perl (<< 3.07-1), libmime-base64-perl (<< 3.07-1), libtime-hires-perl (<< 1.86-1), libstorable-perl (<< 2.15-1)
Replaces: perl-base (<< 5.8.8-1), perl-5.005 (<< 6), perl-5.6 (<< 6), perl-doc (<< 5.8.0-1), perl-modules (<< 5.8.1-1), libdigest-md5-perl, libmime-base64-perl, libtime-hires-perl, libstorable-perl 
Provides: data-dumper, perl5, libdigest-md5-perl, libmime-base64-perl, libtime-hires-perl, libstorable-perl 
Recommends: perl-doc
Suggests: libterm-readline-gnu-perl | libterm-readline-perl-perl
Description: Larry Wall's Practical Extraction and Report Language
 An interpreted scripting language, known among some as "Unix's Swiss
 Army Chainsaw".
 .
 Perl is optimised for scanning arbitrary text files and system
 administration.  It has built-in extended regular expression matching
 and replacement, a data-flow mechanism to improve security with
 setuid scripts and is extensible via modules that can interface to C
 libraries.

=== debian/rules ===
#!/usr/bin/make -f

#
# debian/rules for perl.
#

export SHELL = /bin/sh

fullversion := $(shell /bin/bash debian/config.debian --full-version)
version     := $(shell /bin/bash debian/config.debian --version)
installtype := $(shell /bin/bash debian/config.debian --install-type)
test_target := $(shell /bin/bash debian/config.debian --test-target)
strip	    := $(shell /bin/bash debian/config.debian --strip)
srcdir      := $(shell pwd)
packages    := $(shell sed -n 's/^Package: *\(.*\)/\1/p' debian/control)
tmp	    = debian/tmp
bin         = $(tmp)/usr/bin
man         = $(tmp)/usr/share/man
lib         = $(tmp)/usr/lib/perl/$(version)
share       = $(tmp)/usr/share/perl/$(version)
build	    = debian/build
patches     = patches-applied

checkdir    = test -d debian
checkroot   = test `id -u` -eq 0
checkperl   = $(SHELL) debian/checkperl

# control file substitutions
subst_upstream = -VUpstream-Version=$(fullversion)
subst_perlapi  = -Vperlapi:Provides="`./perl.static debian/mkprovides`"

build: build-stamp
install: install-stamp

build-stamp: perl.static perl.debug libperl.so.$(fullversion)
	touch $@

config.over: debian/config.over
	cp $? $@

perl.static: config.over 
	$(checkdir)
	rm -f libperl.so* # must be built last
	-$(MAKE) distclean
	$(SHELL) debian/config.debian --static
	$(MAKE) perl $(test_target)
	mv libperl.a libperl-static
	mv perl perl.static

perl.debug: config.over 
	$(checkdir)
	rm -f libperl.so* # must be built last
	-$(MAKE) distclean
	$(SHELL) debian/config.debian --debug
	$(MAKE) perl
	mv libperl.a libperl-debug
	mv perl perl.debug

libperl.so.$(fullversion): config.over
	$(checkdir)
	-$(MAKE) distclean
	$(SHELL) debian/config.debian --shared
	$(MAKE) SHRPLDFLAGS='$$(LDDLFLAGS) -Wl,-soname,libperl.so.$(version)' $@
	ln -s libperl.so.$(fullversion) libperl.so.$(version)
	ln -s libperl.so.$(version) libperl.so
	$(MAKE) all $(test_target) || { rm -f libperl.so*; exit 1; }

clean:
	$(checkdir)
	$(checkroot)
	test -f $(patches)	# maintainer sanity check
	-$(MAKE) distclean
	rm -rf config.over perl.static perl.debug libperl-static \
	    libperl-debug libperl.so* build-stamp install-stamp \
	    t/auto debian/shlibs.local debian/perl-base.shlibs \
	    debian/libperl$(version).shlibs debian/substvars \
	    debian/files debian/list.tmp $(tmp) $(build)

install-stamp: build-stamp
	$(checkperl)
	$(checkroot)
	$(checkdir)
	rm -rf $(tmp) $(build)

	$(MAKE) install
	# remove temporary prefix on install vars and switch man
	# extensions to 1p and 3pm for vendor module installs
	./perl.static -i -pe 's!$(srcdir)/$(tmp)/!/! if /install/;' \
	    -e 's/^(man1ext=).*/$$1'\''1p'\''/;' \
	    -e 's/^(man3ext=).*/$$1'\''3pm'\''/;' \
		$(lib)/Config.pm $(lib)/Config_heavy.pl

	# convert required header files
	-cd /usr/include; $(srcdir)/perl.static -I $(srcdir)/lib \
	    $(srcdir)/utils/h2ph -a -d $(srcdir)/$(lib) \
		`cat $(srcdir)/debian/headers`

	# fix up generated headers
	./perl.static -Ilib debian/fixheaders $(lib)

	# simple wrapper around Errno module
	cp debian/errno.ph $(lib)

	# remove some cruft
	rm -f $(bin)/suidperl
	rm -f $(lib)/.packlist
	rm -f $(lib)/CORE/sperl.o

	# installperl copies the symlinks as a files
	rm -f $(lib)/CORE/libperl.so $(lib)/CORE/libperl.so.$(version)

	# remove versioned binary, relink after moving files
	rm -f $(bin)/perl$(fullversion)

	# relocate perl libraries and create links
	cp libperl-static $(tmp)/usr/lib/libperl.a
	cp libperl-debug $(tmp)/usr/lib/libperld.a
	mv $(lib)/CORE/libperl.so.$(fullversion) $(tmp)/usr/lib

	ln -s libperl.so.$(fullversion) $(tmp)/usr/lib/libperl.so.$(version)
	ln -s libperl.so.$(version) $(tmp)/usr/lib/libperl.so

	# move to full version (symlinks created in perl-base below)
	mv $(lib) $(tmp)/usr/lib/perl/$(fullversion)
	mv $(share) $(tmp)/usr/share/perl/$(fullversion)

ifeq ($(installtype),static)
	cp perl.static $(bin)/perl
endif

	# install debug binary as debugperl
	cp perl.debug $(bin)/debugperl

	# split packages
	for p in $(packages); \
	do \
	    test -f debian/$$p.files || exit 1; \
	    mkdir -p $(build)/$$p; \
	    (cd $(tmp); \
		find `cat ../$$p.files ../$$p.files.$(installtype) 2>/dev/null` \
		    ! -type d) >debian/list.tmp; \
	    (cd $(tmp); cpio -vdumpl ../build/$$p) <debian/list.tmp 2>&1 | \
		grep -v ' linked to '; \
	    (cd $(tmp); ../../perl.static -nle unlink) <debian/list.tmp; \
	done

	# ensure that all file have been moved from debian/tmp
	test `find $(tmp) ! -type d | wc -l` -eq 0

	# move pod out of -base modules and into .pod files in -doc
	./perl.static debian/splitdoc $(build)/perl-base

	# re-create versioned link so that suidperl works
	ln $(build)/perl-base/usr/bin/perl \
	    $(build)/perl-base/usr/bin/perl$(fullversion)

	# provide suidperl link
	ln -s perl $(build)/perl-suid/usr/bin/suidperl

	# create symlinks to match @INC
	ln -s $(fullversion) $(build)/perl-base/usr/lib/perl/$(version)
	ln -s $(fullversion) $(build)/perl-base/usr/share/perl/$(version)

	# move section 1 manual pages back to perl for installed programs
	mkdir -p $(build)/perl/usr/share/man/man1
	find $(build)/perl/usr/bin -type f -printf "%f\n" | \
	    while read prog; \
	    do \
		m=$(build)/perl-doc/usr/share/man/man1/$$prog.1; \
		if test -f $$m; \
		then \
		    mv $$m $(build)/perl/usr/share/man/man1; \
		else \
		    echo "warning: no manual page for $$prog" >&2; \
		fi; \
	    done

	# remove some linked man pages (symlinked later and cause
	# problems as-is when compressing)
	rm -f $(build)/perl/usr/share/man/man1/pstruct.1 \
	    $(build)/perl/usr/share/man/man1/psed.1

	# the diagnostics module needs perldiag.pod
	mkdir $(build)/perl-modules/usr/share/perl/$(fullversion)/pod
	mv $(build)/perl-doc/usr/share/perl/$(fullversion)/pod/perldiag.pod \
	    $(build)/perl-modules/usr/share/perl/$(fullversion)/pod

	# copy dummy perldoc to perl package
	cp debian/perl.perldoc $(build)/perl/usr/bin/perldoc
	chmod 755 $(build)/perl/usr/bin/perldoc

	# install rename script to bin (as prename, alternative configured)
	cp debian/rename $(build)/perl/usr/bin/prename
	chmod 755 $(build)/perl/usr/bin/prename

	./perl.static -Ilib $(build)/perl/usr/bin/pod2man --official \
	    debian/rename >$(build)/perl/usr/share/man/man1/prename.1

	# install docs
	for p in $(packages); \
	do \
	    doc=$(build)/$$p/usr/share/doc; \
	    test -d $$doc || mkdir -p $$doc; \
	    if test -f debian/$$p.docs; \
	    then \
		while read src target; \
		do \
		    d=`expr $$target : '\([^/][^/]*\)'`; \
		    test -d $$doc/$$d || mkdir $$doc/$$d; \
		    cp -p $$src $$doc/$$target; \
		done <debian/$$p.docs; \
	    fi; \
	    test -d $$doc/$$p || ln -s perl $$doc/$$p; \
	done

	# move module docs to /usr/share/doc/perl
	while read src target; \
	do \
	    doc=$(build)/perl-doc/usr/share/doc/perl/$$target; \
	    test -d $$doc || mkdir $$doc; \
	    mv $(build)/perl-modules/usr/share/perl/$(fullversion)/$$src $$doc; \
	done <debian/perl-doc.moduledocs

	# remove empty directories left after moving module docs
	find $(build)/perl-modules/usr/share/perl/$(fullversion) \
	    -depth -type d -empty | xargs -r rmdir

	# want these in /etc since /usr may not be writable
	mkdir -p $(build)/perl-modules/etc/perl/CPAN \
	    $(build)/perl-modules/etc/perl/Net

	# default configuration for libnet
	cp debian/libnet.cfg $(build)/perl-modules/etc/Net

	# compress
	find $(build)/*/usr/share/man -type f -print | xargs -r gzip -9
	find $(build)/*/usr/share/doc -type f \
	    \( -name changelog\* -o \( -size +4k ! -name copyright \) \) \
	    -print | xargs -r gzip -9

ifeq ($(strip),yes)
	# strip
	find $(build)/*/usr/bin $(build)/*/usr/lib -type f \
	    \( -name \*.so\* -o -name \*.a -o -perm +111 \) -print | \
	    grep -v ^$(build)/perl-debug/ | \
	    while read f; \
	    do \
		case `file $$f` in \
		*ELF*) strip --remove-section=.comment \
		    --remove-section=.note $$f;; \
		esac; \
	    done
endif

	# fixperms
	find $(build) -print | xargs -r chown -h root:root
